// k2.h
//
// Written by Mike Studer AB6CV
// 9 April 2003
//
#ifndef K2_H
#define K2_H

// OS includes
#include <unistd.h>
#include <termios.h>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/ioctl.h>

// Qt includes
#include <qstring.h>
#include <qmutex.h>

using namespace std;

class k2
{
 private:
    int fd;
    int erno;
    int status;
    struct termios newtio, oldtio;
    char buf[3];
    QString qbuf;
    QString qbuf2;
    QMutex mutex;
   
 public:

// open up serial port
   void init_k2(int);
 
// read K2 data
   QString read_k2(void);
   
// write data to K2
   void cmd_k2(char *);
   
// restore port
   void restoreTerm(void);
  
};

#endif
